/*
 * https://github.com/Zer0Mem0ry/SignatureScanner
 */

#pragma once

#include <iostream>
#include <string>

#include <Windows.h>
#include <TlHelp32.h>

// datatype for a module in memory (dll, regular exe) 
struct module
{
	DWORD dwBase, dwSize;
};

class SignatureScanner
{
public:
	module TargetModule;  // Hold target module
	DWORD  TargetId;      // for target process

	void GetProcess() {
		TargetId = GetCurrentProcessId();
	}

	// For getting information about the executing module
	module GetModule() {
		HANDLE hmodule = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, TargetId);
		MODULEENTRY32 mEntry;
		mEntry.dwSize = sizeof(mEntry);

		Module32Next(hmodule, &mEntry);
		CloseHandle(hmodule);

		TargetModule = { (DWORD)mEntry.hModule, mEntry.modBaseSize };
		return TargetModule;
	}

	bool MemoryCompare(const BYTE* bData, const BYTE* bMask, const char* szMask) {
		for (; *szMask; ++szMask, ++bData, ++bMask) {
			if (*szMask == 'x' && *bData != *bMask) {
				return false;
			}
		}
		return (*szMask == NULL);
	}

	DWORD FindSignature(DWORD start, DWORD size, const char* sig, const char* mask) {
		BYTE* data = (BYTE*)start;
		for (DWORD i = 0; i < size; i++) {
			if (MemoryCompare((const BYTE*)(data + i), (const BYTE*)sig, mask)) {
				return start + i;
			}
		}
		return NULL;
	}
};